/* WI_M0_1Box__01.ino
 *  Modified for the M0 1Box project (Adafruit QT-PY in the small Hammond box 1551H).
 *  2021-02-01 prefontDon@gmail.com
 *  "Soft RTC" Reference: https://learn.adafruit.com/adafruit-adalogger-featherwing/adafruit2-rtc-with-arduino
 *  u8x8 library: https://www.arduinolibraries.info/libraries/u8g2 and https://github.com/olikraus/u8g2/wiki/fntlist8x8
*/ 
//#include <ArduinoLowPower.h> // Available if you wish to use it instead of "delay()".
int redLED = A2;               // Pin A2 is output to the red LED.
//int greenLED = A1;
//int blueLED = A0;
//int LDR = Ax;                // Pin Ax is output from LDR device.
int PIRpin = A3;               // Pin A3 input from PIR (passive infrared) motion sensor.
//int buzzer = Ax;             // Pin Ax is output to the buzzer.
int pirState = LOW;            // We'll start with a LOW state: no motion was detected.

#include <U8x8lib.h>           // RAM-economical text-only OLED display driver! Ideal for ATmega328 microcontrollers.
//U8X8_SH1106_128X64_NONAME_HW_I2C u8x8(/* reset=*/ U8X8_PIN_NONE);   // 4-pin I2C 1.3" 128x64 OLED with no Reset.
U8X8_SSD1306_128X64_NONAME_HW_I2C u8x8(/* reset=*/ U8X8_PIN_NONE);    // 4-pin I2C 1.3" 128x64 OLED with no Reset.

#include <Wire.h>                     // For I2C (SCL, SDA pins).                    
#include <Adafruit_Sensor.h>          // For all Adafruit sensors. 
#include <Adafruit_BME280.h>          // BME280 sensor: temperature, humidity, barometric pressure.
Adafruit_BME280 bme;                  // Uses I2C. Object name is "bme".
#define SEALEVELPRESSURE_HPA (1008.00)// Google "barometric pressure YourCity" to get the current value for determining altitude.
                                      // Altitude is not very accurate so I don't use it.                                         
#include <RTClib.h>                   // "Soft" Real time clock library used with Cortex M0/M4, etc.
RTC_Millis rtc;                       // Taken from "softrtc.ino" example in RTClib library. Object name is "rtc".
//char daysOfTheWeek[7][12] = {"Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"};                 
/*
//Include the SD library:
#include <SPI.h>                    // Hardware SPI library: D10:SS, MOSI, MISO , SCK.
#include <SD.h>                     // SD library.
File statsFile;                     // SD object name to write weather stats to; filename will be THBP.txt.
*/
long oledOnTime = 8000;             // Milliseconds of OLED display on-time.
                                    // Note: PIR built-in "on" time value is 7 to 8s so make sure oledOnTime is a larger value.
long SdWriteTime = 60000;           // Milliseconds (60s) between stats writes to microSD card.
unsigned long currentMillis = 0;    // millis = mS since reboot. This is a copy of that value for this point in time.
unsigned long previousMillis = 0;   // mS elapsed since last "currentMillis = millis()".  
unsigned long oledMillis = 0;       // OLED on-time in ms.
unsigned long totalOledMillis = 0;  // OledMillis time since last reset.
unsigned long sdMillis = 0;         // SD time since last write.
unsigned long totalSdMillis = 0;    // SD time since last write
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void setup(void) {
  pinMode(redLED, OUTPUT);      // Set redLED pin as output to LED.
//pinMode(greenLED, OUTPUT);
//pinMode(blueLED, OUTPUT);
  
  pinMode(PIRpin,INPUT_PULLUP); // PIR outputs 3.3v HIGH for about 7 seconds to indicate motion was sensed.
  u8x8.begin();                 // Start OLED: initDisplay, clearDisplay, setPowerSave.
  u8x8.setPowerSave(0);         // Disable OLED power save function. https://github.com/olikraus/u8g2/wiki/u8x8reference#setpowersave
  u8x8.clearDisplay();          // Clears entire display, not just one line.
  bme.begin();                  // Start BME280.                
  rtc.begin(DateTime(F(__DATE__), F(__TIME__)));  // Sets the RTC to the date & time this sketch was compiled.
// This line sets the RTC with an explicit date & time. 
// For example: January 21, 2021 at 3pm you would call: rtc.adjust(DateTime(2021, 1, 21, 15, 0, 0)); 
  Serial.begin(9600);  // Pass/fail diags can be seen in Serial Monitor. 
/*  
  Serial.print(F("Initializing SD card..."));
  pinMode(7, OUTPUT);   // Note that even if it's not used as the CS pin, the hardware SPI SS pin (10) 
                        // must be left as an output or the SPI SD library functions will not work. 
  if (!SD.begin(7)) {
  Serial.println(F(" SD initialization failed!\n"));
    return;  }
  Serial.println(F("\nSD initialization done.\n")); 
*/
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void loop(void) {
//  monSD();                  // Monitor SD. Write stats to microSD card every SdWriteTime(60000ms, one minute).
  monPIR();                 // Monitor PIR. Display stats on OLED initially for oledOnTime (8000ms) and whenever motion is detected.
  currentMillis = millis(); // Update the current time after each loop pass. Used to determine if either counter above expired.
  delay(1000);
//LowPower.deepSleep(1000); // LowPower.deepSleep(milliseconds);
//millsPlot();              // Use "millsPlot" and Serial Plotter to plot just barometric pressure. Start it after the sketch downloads.
                            // Ensure you comment out all lines that begin with "Serial.println" first.
//millsTS();                // Use "millsTS" to troubleshoot your system.
}  
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/* microSD Monitoring Code */  
/*
void monSD(void) {  
  totalSdMillis = totalSdMillis + (currentMillis - previousMillis);      
  if(totalSdMillis >=  SdWriteTime) {   // Write stats to SD and play tone if time between SD writes exceeds threshold.
    totalSdMillis = 0;  
    outSD();                        }
}
*/
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void monPIR(void) {  /* PIR Monitoring Code */    
/* Several lines (commented out) below have been added for troubleshooting purposes */
  totalOledMillis = totalOledMillis + (currentMillis - previousMillis); 
  if((digitalRead(PIRpin) == LOW)  && (totalOledMillis < oledOnTime))  { /* NO movement. */
    pirState = LOW;  
//  millsTS();
  } else 
  if((digitalRead(PIRpin) == LOW) && (totalOledMillis >= oledOnTime))  { /* NO movement. */
    pirState = LOW; 
//  millsTS(); 
//  Serial.print(F("\n------------------------------------------------------------------------ Reset OLED timer "));
//  Serial.println(F("------------------------------------------------------------------------------------------")); 
    totalOledMillis = 0; 
//  millsTS();
    u8x8.clearDisplay();    // Clear the OLED display.
    offLED();               // Turn off the LED.
  } else
  if((digitalRead(PIRpin) == HIGH) && (totalOledMillis < oledOnTime))  { /* Movement! */
    pirState = HIGH;
//  millsTS();  
    onLED();                // Turn on the LED.
    outOLEDbig();           // Display just T and F in large font.
    u8x8.clearDisplay(); 
    outOLED();              // Display the OLED info.
  } else 
  if((digitalRead(PIRpin) == HIGH)  && (totalOledMillis >= oledOnTime))  { /* Movement! */
    pirState = HIGH; 
//  millsTS();
    totalOledMillis = 0; 
//  millsTS();  
    u8x8.clearDisplay();              // Clear the OLED display to stop displaying the stats.
    offLED();                         // Turn off the LED.
  }
    previousMillis = currentMillis;   // Remember the new current time.
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
void outOLEDbig() {              // Displays T,H and BP in larger font.
  DateTime now = rtc.now();      // Must be in each function's scope.
  u8x8.clearDisplay();   
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 

  float Tc = bme.readTemperature();           // Temp in C.  
  u8x8.drawString(3,0,"T: ");    // T:            
  u8x8.setCursor(7,0);           //                                  
  u8x8.print(Tc,0);              // T: xx
  u8x8.drawString(11,0,"c");     // T: xxc   
       
  float H = bme.readHumidity();                // Humidity %.
  u8x8.drawString(3,3,"H: ");    // H:            
  u8x8.setCursor(7,3);           //               
  u8x8.print(H,0);               // H: xx
  u8x8.setFont(u8x8_font_px437wyse700b_2x2_f); // Supports "%" symbol.   
  u8x8.drawString(11,3,"%");     // H: xx%        
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); // No "%" symbol.
  
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000). 
  u8x8.drawString(1,6,"BP: ");   // BP:            
  u8x8.setCursor(7,6);           //                   
  u8x8.print(BP,0);              // BP: xxx
  u8x8.drawString(14,6,"k");     // BP: xxx k // KiloPascals 
        
  delay(2500);                   // Time to read the large print.
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void outOLED() {
  DateTime now = rtc.now();         // Must be in each function's scope.
  u8x8.setFont(u8x8_font_chroma48medium8_r); // Font chosen.
  u8x8.drawString(0,0," WEATHER INSIDE");    // Display the program title. 
  u8x8.drawString(0,2,"T: ");       // Display Temperature in C (default) and F.
  u8x8.setCursor(4,2);
  float Tc = bme.readTemperature(); // Temp in C.
  u8x8.print(Tc,0); 
  u8x8.drawString(6,2,"c");                               
  u8x8.setCursor(8,2);
  float Tf = ((Tc * 1.8) + 32);     // Temp in F.
  u8x8.print(Tf,0);     
  u8x8.drawString(10,2,"f");  
  u8x8.drawString(0,3,"H: ");       // Display Humidity in %.
  u8x8.setCursor(4,3);
  float H = bme.readHumidity();     // Humidity %.
  u8x8.print(H,0);
  u8x8.drawString(6,3,"%");
  u8x8.drawString(0,4,"DP:");       // Display Dew Point in C and F.
  u8x8.setCursor(4,4);
  float TDPc = ((100 - H) / 5);     // Dew Point temperature in C.
  u8x8.print(TDPc,0);
  u8x8.drawString(6,4,"c"); 
  u8x8.setCursor(8,4);  
  float TDPf = ((TDPc * 1.8) + 32); // Dew Point temperature in F.
  u8x8.print(TDPf,0);
  u8x8.drawString(10,4,"f");  
  u8x8.drawString(0,5,"HX: ");      // Display Humidex in C and F using formula at bottom.
  u8x8.setCursor(4,5);
  float TDPk = TDPc + 273.15;       // Dew Point temperature in K. 
  float HXc = Tc + (0.5555 * (pow(6.11,(5417.7530 * ((1/273.16) - (1/TDPk))) - 10)));  // Calculate Humidex in C based on Dew Point and Humidity.
  u8x8.print(HXc,0);
  u8x8.drawString(6,5,"c");  
  u8x8.setCursor(8,5);  
  float HXf = ((HXc * 1.8) + 32);   // Humidex in F.
  u8x8.print(HXf,0);      
  u8x8.drawString(10,5,"f"); 
  u8x8.drawString(0,6,"BP:");       // Display Barometric Pressure in kilo Pascals (kPa)
  u8x8.setCursor(4,6); 
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  u8x8.print(BP,1);
  u8x8.drawString(10,6,"kPa");  
/*  
  float BPmm = (BP * 7.50062);      // Barometric pressure in millimeters mercury (mmHg).
  u8x8.print(BPmm,1);
  u8x8.drawString(10,6,"mmHg");
  float BPin = (BP * 0.2953);       // Barometric pressure in inches mercury (inHg).
  u8x8.print(BPin,1);
  u8x8.drawString(10,6,"inHg"); 
*/
  u8x8.setCursor(0,7);              // YY/MM/DD HH:MM
  u8x8.print(now.year(),DEC);
  u8x8.drawString(2,7,"/");
  u8x8.setCursor(3,7);
  u8x8.print(now.month(),DEC);
  u8x8.drawString(5,7,"/");
  u8x8.setCursor(6,7);
  u8x8.print(now.day(), DEC);    
  u8x8.drawString(8,7," ");
  u8x8.setCursor(9,7);
  u8x8.print(now.hour(), DEC);    
  u8x8.drawString(11,7,":");
  u8x8.setCursor(12,7);
  u8x8.print(now.minute(), DEC);
  u8x8.drawString(14,7," ");
//u8x8.drawString(14,7,":");
//u8x8.print(now.second(), DEC);
//u8x8.setCursor(0,8);
//u8x8l.print(daysOfTheWeek[now.dayOfTheWeek()]);  
  delay(5500);                        // Time to read the small print.
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*void outSD() {               // Write stats periodically to the microSD card.
  DateTime now = rtc.now();  // Must be in each function's scope.
//Open the file. Note that only one file can be open at a time so you have to close the current one before opening another.
  statsFile = SD.open("THBP.txt", FILE_WRITE);      // SPI. 
  if (statsFile) {                                  // If the file opened okay, write to it and to Serial Monitor.
    Serial.println(F("\n----------- Writing stats to THBP.txt and resetting totalSdMillis counter -----------\n"));
  } else {
    Serial.println(F("\nError opening THBP.txt\n")); // Print an error to the Serial Monitor if the file didn't open.
  }      
  statsFile.print(now.year(),DEC);   // Write date and time to SD: YY/MM/DD HH:MM.
  statsFile.print(F("/"));
  statsFile.print(now.month(),DEC);
  statsFile.print(F("/"));
  statsFile.print(now.day(), DEC); 
  statsFile.print(F(" "));  
  statsFile.print(now.hour(), DEC);  
  statsFile.print(F(":"));    
  statsFile.print(now.minute(), DEC);
  statsFile.print(F(":"));
  statsFile.print(now.second(), DEC); 
  statsFile.print(F("\t\tT:\t"));   // T:xxc xxf
  float Tc = bme.readTemperature(); // Temp in C.
  statsFile.print(Tc,0);            
  statsFile.print(F("c\t")); 
  float Tf = ((Tc * 1.8) + 32);     // Temp in F.
  statsFile.print(Tf,0);
  statsFile.print(F("f"));  
  statsFile.print(F("\t\tH:\t"));   // H:%
  float H = bme.readHumidity();     // Humidity %.
  statsFile.print(H,0);
  statsFile.print(F("%"));  
  statsFile.print("\t\tDP:\t");     // DP:xxc xxf
  float TDPc = ((100 - H) / 5);     // Dew Point temperature in C.
  statsFile.print(TDPc,0);
  statsFile.print(F("c\t"));
  float TDPf = ((TDPc * 1.8) + 32); // Dew Point temperature in F.
  statsFile.print(TDPf,0);
  statsFile.print(F("f"));
  statsFile.print(F("\t\tHX:\t"));  // HX:xxc xxf
  float TDPk = TDPc + 273.15;       // Dew Point temperature in K. 
  float HXc = Tc + (0.5555 * (pow(6.11,(5417.7530 * ((1/273.16) - (1/TDPk))) - 10)));  // Calculate Humidex in C based on Dew Point and Humidity.
  statsFile.print(HXc,0);
  statsFile.print(F("c\t")); 
  float HXf = ((HXc * 1.8) + 32);   // Humidex in F.
  statsFile.print(HXf,0);  
  statsFile.print(F("f")); 
  statsFile.print(F("\t\tBP:\t"));  // HX:xxc xxf
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  float BPmm = (BP * 7.50062);      // Barometric pressure in millimeters mercury (mmHg).
  float BPin = (BP * 0.2953);       // Barometric pressure in inches mercury (inHg).
  statsFile.print(BP,1);
  statsFile.print(F(" kPa\t"));   // kilo Pascals.
  statsFile.print(BPmm,1);
  statsFile.print(F(" mmHg\t"));  // millimeters Mercury.
  statsFile.print(BPin,1);  
  statsFile.println(F(" inHg"));  // inches Mercury.
  statsFile.close();                  
}
*/
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void onLED() {
  digitalWrite(redLED, HIGH);   // turn the LED on (HIGH is the voltage level)   
//digitalWrite(greenLED, HIGH);
//digitalWrite(blueLED, HIGH); 
  }
void offLED() {  
  digitalWrite(redLED, LOW);    // turn the LED off by making the voltage LOW
//digitalWrite(greenLED, LOW);  
//digitalWrite(blueLED, LOW);      
}
void blinkLed() {
  digitalWrite(redLED, HIGH);   // turn the LED on (HIGH is the voltage level)
//digitalWrite(greenLED, HIGH); 
//digitalWrite(blueLED, HIGH); 
  delay(100);
//LowPower.deepSleep(100);      // wait a moment
  digitalWrite(redLED, LOW);    // turn the LED off by making the voltage LOW
//digitalWrite(greenLED, LOW); 
//digitalWrite(blueLED, LOW); 
  delay(100);
//LowPower.deepSleep(100);      // wait a moment
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void millsTS(void) {   // For TroubleShooting purposes. Keeps track of both SD and OLED times.
  Serial.print(F("currentMillis("));
  Serial.print(currentMillis);
  Serial.print(F(" ms)"));
  Serial.print(F(" - previousMillis("));
  Serial.print(previousMillis);
  Serial.print(F(" ms)"));
  Serial.print(F(" = "));
  Serial.print(currentMillis - previousMillis);
  Serial.print(F(" ms\t")); 
  Serial.print(F("totalOledMillis = "));
  Serial.print(totalOledMillis);
  Serial.print(F(" ms\t"));
  Serial.print(F("totalSdMillis = "));
  Serial.print(totalSdMillis);
  Serial.print(F(" ms\t"));
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  float BPmm = (BP * 7.50062);      // Barometric pressure in millimeters mercury (mmHg).
  float BPin = (BP * 0.2953);       // Barometric pressure in inches mercury (inHg).
  Serial.print(F("BP = "));
  Serial.print(BP,1);
  Serial.print(F(" kPa  "));
  Serial.print(BPmm,1);
  Serial.print(F(" mmHg  "));
  Serial.print(BPin,2);
  Serial.print(F(" inHg\t"));      
  Serial.print(F("pirState = "));
  Serial.println(pirState);
}  
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
void millsPlot(void) {                // Plot the BP using "Tools|Serial Plotter".
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  float BPmm = (BP * 7.50062);        // Barometric pressure in millimeters mercury (mmHg).
  float BPin = (BP * 0.2953);         // Barometric pressure in inches mercury (inHg).
  Serial.print("BP ");
  Serial.println(BP,1);
}  
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
// humidex = air temperature + (0.5555)*(e - 10.0) where e = 6.11 * exp [5417.7530 * ((1/273.16) - (1/dewpoint in kelvins))]
